# ==============
# File: binaryheap.py
# By: Jack Holdsworth - 20023933
# Use: binary heap decoder
# Written on: Python 3.8
# ==============


def decode_bt(string):
    # a binary heap decode function without the use of OOP

    # the heap (tree)
    tree = " ETIANMSURWDKGOHVF*L*PJBXCYZQ**54*3*¿?2&*+****16=/***(*7***8*90*************_****\"**.********'**-********;!*)***¡*,****:****************$***********************************************************************************************************************"

    output = ""
    parent = 1 # base value of tree +1 for offset by ' ' character
    for i in range(len(string)):
        if i < len(string) - 1 : # head and body of the input string
            if string[i] == " ": # end of letter
                output += tree[parent - 1] # at the end of the letter we grab the current node (-1 offset) and append to output
                parent = 1 # reset tree
            if string[i] == ".": # go to the left child
                parent = 2 * parent # left child's position
            elif string[i] == "-": # go to the right child
                parent = 2 * parent + 1 # right child's position
        else: # tail of the input string
            if string[i] == ".": # go to the left child
                parent = 2 * parent # left child's position
            if string[i] == "-": # go to the right child
                parent = 2 * parent + 1 # right child's position
            output += tree[parent - 1] # at the end of the letter we grab the current node (-1 offset) and append to output
            parent = 1 # reset tree
    return output.replace("  ", " ")

if __name__ == '__main__':
    print("=== TASK 1 by Jack H ===")
    print(decode_bt(".... . .-.. .-.. --- -.-.-- --..--   - .... .. ...   .. ...   - .- ... -.-   .----"))
    print(decode_bt("..   -.-. .- -.   -.. ---   ... .--. . -.-. .. .- .-..   -.-. .... .- .-. .- -.-. - . .-. ...   .-.. .. -.- .   .-..."))
    print("========================")